# encoding: utf-8

# Extending of standart IO class
class IO
  include Timeout


  # Reads the next "packet" from I/O stream. Packets are separated by time delay.
  # @param time [Integer] time delay between packets in seconds.
  # @example
  #    server.print "Foo"
  #    sleep 0.1
  #    server.print "Bar"
  #    sleep 0.1
  #    server.print "Foo"
  #    client.gett(0.1)    #=> "Foo"
  #    client.gett(0.2)    #=> "BarFoo"
  # @return [String] recieved packet string
  def gett(time)
    raw = getc
    loop {
      begin
        timeout(time){raw << getc}
      rescue Timeout::Error
        break
      end
    }
    raw
  end
end
