# encoding: utf-8

module Rumid
  #Extended GServer, baked to work with Rumid::Server servers
  class TcpServer < GServer
    # @param port [Integer] port to be listened by the server
    # @param protocol_server [Rumid::Server] klass the extended Server class
    def initialize(port, protocol_server, *args)
      super(port, *args)
      @protocol_server = protocol_server
    end


    # Overriden Gserver#serve function.
    # @note Typicaly you should not call this method
    # @param session [IO] I/O stream from TCP connection
    def serve(session)
      loop{
        begin
          @protocol_server.new.serve(session)
        rescue Rumid::Errors::NotValidRequestError
          log "Error in validation occured!"
        end
      }
    end
  end
end
